using Osci.Messagetypes;

namespace Osci.Exceptions
{
    /// <summary> Diese Exception wird für die in der OSCI 1.2 Transport-Spezifikation
    /// definierten Fehlermeldungen verwendet.
    /// 
    /// <p>Copyright © 2018 Freie Hansestadt Bremen</p>
    /// <p>Erstellt von Governikus GmbH &amp; Co. KG</p>
    /// <p>Diese Bibliothek kann von jedermann nach Maßgabe der Bremer Lizenz für
    /// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen können
    /// unter der URL www.osci.de abgerufen oder bei der
    /// Koordinierungsstelle für IT-Standards (KoSIT), Schillerstr. 1,
    /// 28195 Bremen schriftlich angefordert werden.</p>
    /// 
    /// <p>Author: P. Ricklefs, N. Büngener</p> 
    /// <p>Version: 1.8</p>
    /// </summary>
    public class OsciErrorException
        : OsciException
    {
        public OsciMessage OsciMessage
        {
            get; private set;
        }

        public OsciErrorException(string errorCode)
            : base(errorCode)
        {
        }

        public OsciErrorException(string errorCode, OsciMessage osciMessage)
            : base(errorCode)
        {
            OsciMessage = osciMessage;
        }
    }
}