using Osci.Exceptions;

namespace Osci.Roles
{
    /// <summary> Diese Exception zeigt an, dass einem Rollenobjekt für eine unzulässige Operation
    /// verwendet wurde. <p>Beispiel: An die Methode ContentContainer.sign(Role) wird ein
    /// Role-Objekt übergeben, welches kein Signer-Objekt enthält.</p>
    /// 
    /// <p>Copyright © 2018 Freie Hansestadt Bremen</p>
    /// <p>Erstellt von Governikus GmbH &amp; Co. KG</p>
    /// <p>Diese Bibliothek kann von jedermann nach Maßgabe der Bremer Lizenz für
    /// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen können
    /// unter der URL www.osci.de abgerufen oder bei der
    /// Koordinierungsstelle für IT-Standards (KoSIT), Schillerstr. 1,
    /// 28195 Bremen schriftlich angefordert werden.</p>
    /// 
    /// <p>Author: P. Ricklefs, N. Büngener</p> 
    /// <p>Version: 1.8</p>
    /// </summary>
    public class OsciRoleException 
        : OsciException
    {

        public OsciRoleException(string message) 
            : base(message)
        {
        }

        public OsciRoleException(string message, string errorCode) 
            : base(message, errorCode)
        {
        }
    }
}