using Osci.Exceptions;

namespace Osci.Signature
{
    /// <summary>Diese Exception zeigt ein Problem bei Signaturvorgängen an.
    /// Die Bibliothek faßt auch einige JCE/JCA-Exceptions hiermit zusammen, um 
    /// (aus Sicherheitsgründen) keine detaillierten Informationen über fehlgeschlagene
    /// Signierversuche zu liefern.
    /// 
    /// <p>Copyright © 2018 Freie Hansestadt Bremen</p>
    /// <p>Erstellt von Governikus GmbH &amp; Co. KG</p>
    /// <p>Diese Bibliothek kann von jedermann nach Maßgabe der Bremer Lizenz für
    /// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen können
    /// unter der URL www.osci.de abgerufen oder bei der
    /// Koordinierungsstelle für IT-Standards (KoSIT), Schillerstr. 1,
    /// 28195 Bremen schriftlich angefordert werden.</p>
    /// 
    /// <p>Author: P. Ricklefs, N. Büngener</p> 
    /// <p>Version: 1.8</p>
    /// </summary>

    public class OsciSignatureException 
        : OsciException
    {
        public OsciSignatureException(string message)
            : base(message)
        {
        }

        public OsciSignatureException(string message, string errorCode) 
            : base(message, errorCode)
        {
        }
    }
}